loadnetflt.sh revision b263fac6f6e7fa933c7bfb2a45d598fe8e458c09
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley#!/bin/bash
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley## @file
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# For development.
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley#
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley#
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# Copyright (C) 2006-2008 Sun Microsystems, Inc.
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley#
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# This file is part of VirtualBox Open Source Edition (OSE), as
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# available from http://www.virtualbox.org. This file is free software;
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# you can redistribute it and/or modify it under the terms of the GNU
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# General Public License (GPL) as published by the Free Software
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# Foundation, in version 2 as it comes in the "COPYING" file of the
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley#
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# Clara, CA 95054 USA or visit http://www.sun.com if you need
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley# additional information or have any questions.
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley#
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleySCRIPT_NAME="loadusb"
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyXNU_VERSION=`LC_ALL=C uname -r | LC_ALL=C cut -d . -f 1`
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyDRVNAME="VBoxNetFlt.kext"
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyBUNDLE="org.virtualbox.kext.VBoxNetFlt"
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darleyif [ "$XNU_VERSION" -ge "9" ]; then
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley DEP_DRVNAME="VBoxDrv.kext"
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darleyelse
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley DEP_DRVNAME="VBoxDrvTiger.kext"
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darleyfi
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyDEP_BUNDLE="org.virtualbox.kext.VBoxDrv"
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darley
cefc5852a36a84f096c732412212ba15a7ea1d22James Darley
cefc5852a36a84f096c732412212ba15a7ea1d22James DarleyDIR=`dirname "$0"`
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyDIR=`cd "$DIR" && pwd`
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyDEP_DIR="$DIR/$DEP_DRVNAME"
155c05bbac47cd2c35bc51c930935fddcbcfd604James DarleyDIR="$DIR/$DRVNAME"
155c05bbac47cd2c35bc51c930935fddcbcfd604James Darleyif [ ! -d "$DIR" ]; then
echo "Cannot find $DIR or it's not a directory..."
exit 1;
fi
if [ ! -d "$DEP_DIR" ]; then
echo "Cannot find $DEP_DIR or it's not a directory... (dependency)"
exit 1;
fi
if [ -n "$*" ]; then
OPTS="$*"
else
OPTS="-t"
fi
trap "sudo chown -R `whoami` $DIR $DEP_DIR; exit 1" INT
# Try unload any existing instance first.
LOADED=`kextstat -b $BUNDLE -l`
if test -n "$LOADED"; then
echo "${SCRIPT_NAME}.sh: Unloading $BUNDLE..."
sudo kextunload -v 6 -b $BUNDLE
LOADED=`kextstat -b $BUNDLE -l`
if test -n "$LOADED"; then
echo "${SCRIPT_NAME}.sh: failed to unload $BUNDLE, see above..."
exit 1;
fi
echo "${SCRIPT_NAME}.sh: Successfully unloaded $BUNDLE"
fi
set -e
# Copy the .kext to the symbols directory and tweak the kextload options.
if test -n "$VBOX_DARWIN_SYMS"; then
echo "${SCRIPT_NAME}.sh: copying the extension the symbol area..."
rm -Rf "$VBOX_DARWIN_SYMS/$DRVNAME"
mkdir -p "$VBOX_DARWIN_SYMS"
cp -R "$DIR" "$VBOX_DARWIN_SYMS/"
OPTS="$OPTS -s $VBOX_DARWIN_SYMS/ "
sync
fi
# On smbfs, this might succeed just fine but make no actual changes,
# so we might have to temporarily copy the driver to a local directory.
sudo chown -R root:wheel "$DIR" "$DEP_DIR"
OWNER=`/usr/bin/stat -f "%u" "$DIR"`
if test "$OWNER" -ne 0; then
TMP_DIR=/tmp/${SCRIPT_NAME}.tmp
echo "${SCRIPT_NAME}.sh: chown didn't work on $DIR, using temp location $TMP_DIR/$DRVNAME"
# clean up first (no sudo rm)
if test -e "$TMP_DIR"; then
sudo chown -R `whoami` "$TMP_DIR"
rm -Rf "$TMP_DIR"
fi
# make a copy and switch over DIR
mkdir -p "$TMP_DIR/"
sudo cp -Rp "$DIR" "$TMP_DIR/"
DIR="$TMP_DIR/$DRVNAME"
# load.sh puts it here.
DEP_DIR="/tmp/loaddrv.tmp/$DEP_DRVNAME"
# retry
sudo chown -R root:wheel "$DIR" "$DEP_DIR"
fi
sudo chmod -R o-rwx "$DIR"
sync
echo "${SCRIPT_NAME}.sh: loading $DIR... (kextload $OPTS \"$DIR\")"
sudo kextload $OPTS -d "$DEP_DIR" "$DIR"
sync
sudo chown -R `whoami` "$DIR" "$DEP_DIR"
kextstat | grep org.virtualbox.kext